﻿Imports FlexCel.XlsAdapter
Imports FlexCel.Report
Imports System.Collections.Generic
Imports System.Linq
Imports Simiweb.DataLinq
Imports Simiweb.DataAccess
Imports Simiweb.BusinessFacade
Imports System.IO
Imports System.Globalization
Imports FlexCel.Core
Imports Helper


Partial Class Utility_EsportaTabelle
    Inherits System.Web.UI.Page
    Private _mbjNotifica As New BllNotifica
    Private _mbjTbc As New BllTbc
    Private _mbjFocolaio As New BllFocolaio
    Private _mobjUSer As New BllUser
    Private _mobjGeo As New BllGeografiche
    Private _mobjMib As New BllMib
    Private _idRegione As String = ""
    Private _idAsl As String = ""
    Private _Username As String = ""
    Private _ruolo As String = ""
    Private _usernameMedico As String = ""
    Protected Overloads Overrides Function SaveViewState() As Object
        Me.ViewState.Add("_idRegione", _idRegione)
        Me.ViewState.Add("_idAsl", _idAsl)
        Me.ViewState.Add("_Username", _Username)
        Me.ViewState.Add("_ruolo", _ruolo)
        Me.ViewState.Add("_usernameMedico", _usernameMedico)

        Return MyBase.SaveViewState
    End Function
    Protected Overloads Overrides Sub LoadViewState(ByVal savedState As Object)
        MyBase.LoadViewState(savedState)
        _idRegione = ViewState("_idRegione")
        _idAsl = ViewState("_idAsl")
        _Username = ViewState("_Username")
        _ruolo = ViewState("_ruolo")
        _usernameMedico = ViewState("_usernameMedico")
    End Sub
    Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        If Not Page.IsPostBack Then

            _Username = User.Identity.Name
            Dim currRoles() As String = Roles.GetRolesForUser(HttpContext.Current.User.Identity.Name)
            Dim ruolo As String = currRoles(0).ToString
            _ruolo = LCase(ruolo)

            If _ruolo = "medico" Then
                _usernameMedico = User.Identity.Name
            Else
                _usernameMedico = Nothing
            End If

            If _ruolo = "asl" Or _ruolo = "regione" Or _ruolo = "laboratorio" Or _ruolo = "medico" Then



                'Dim username As String = User.Identity.Name
                Dim cUser As Utenti_Profilo = _mobjUSer.GetProfiloByUsername(_Username)
                _idRegione = cUser.idRegione
                regione.Enabled = False
                regionefocolaio.Enabled = False

                If _ruolo = "asl" Or _ruolo = "medico" Then
                    _idAsl = cUser.idAsl
                    asl.Enabled = False
                    aslFocolaio.Enabled = False
                End If

            End If
            ImpostaCampi()
            bindCombo()
        End If
    End Sub
    Private Sub ImpostaCampi()
        Dim regioniDs As List(Of JsonDto) = _mobjGeo.GetAllRegioniJson
        Dim aslDs As List(Of JsonDto) = _mobjGeo.GetAllAslByIdRegioneJson(_idRegione)
        Carica(Regione, regioniDs, _idRegione)
        Carica(regionefocolaio, regioniDs, _idRegione)
        Carica(Asl, aslDs, _idAsl)
        Carica(aslFocolaio, aslDs, _idAsl)
    End Sub
    Private Sub Carica(ByRef ctr As DropDownList, ByVal dts As List(Of JsonDto), Optional ByVal sel As String = "")
        ctr.DataValueField = "Codice"
        ctr.DataTextField = "Descrizione"
        ctr.DataSource = dts
        ctr.DataBind()
        ctr.Items.Insert(0, New ListItem("Selezionare...", ""))
        If sel <> "" Then
            ctr.SelectedValue = sel
        End If

    End Sub

    Private Sub SendToBrowser(OutStream As MemoryStream, MimeType As String, FileName As String)
        Response.Clear()
        Response.AddHeader("Content-Disposition", "attachment; filename=" + FileName)
        Dim MemData As Byte() = OutStream.ToArray()
        Response.AddHeader("Content-Length", Convert.ToString(MemData.Length, CultureInfo.InvariantCulture))
        Response.ContentType = MimeType
        Response.BinaryWrite(MemData)
        Response.End()
    End Sub

    Private Sub CreaExcel()
        Dim xls As XlsFile = New XlsFile(True)
        Dim nomefile As String = ""

        If _ruolo = "admin" Or _ruolo = "regione" Or _ruolo = "laboratorio" Then
            nomefile = "notifiche" + anno.SelectedValue + ".xlsx"
            xls.NewFile(7, TExcelFileFormat.v2007)
        Else
            nomefile = "notifiche" + anno.SelectedValue + ".xls"
            xls.NewFile(7, TExcelFileFormat.v2003)
        End If





        xls.ActiveSheet = 1
        xls.SheetName = "notifica"
        xls.ActiveSheet = 2
        xls.SheetName = "anagrafica"
        xls.ActiveSheet = 3
        xls.SheetName = "clinica"
        xls.ActiveSheet = 4
        xls.SheetName = "tbc"
        xls.ActiveSheet = 5
        xls.SheetName = "tbc fattori"
        xls.ActiveSheet = 6
        xls.SheetName = "Mib"
        xls.ActiveSheet = 7
        xls.SheetName = "Malaria"

        AddNotifica(xls, loadNotifica)
        AddAnagrafica(xls, loadAnagrafica)
        AddClinica(xls, loadClinica)
        AddTbc(xls, loadTbc)
        addTbcFattori(xls, loadTbcFattori)
        AddMib(xls, loadMib)
        addMalaria(xls, loadMalaria)
        xls.ActiveSheet = 1
        Dim XlsStream As MemoryStream = New MemoryStream()
        Try
            If _ruolo = "admin" Or _ruolo = "regione" Or _ruolo = "laboratorio" Then
                xls.Save(XlsStream, TFileFormats.Xlsx)
                '
            Else
                xls.Save(XlsStream, TFileFormats.Xls)

            End If
            SendToBrowser(XlsStream, "application/excel", nomefile)
        Finally
            XlsStream.Close()
        End Try
    End Sub
    Private Sub CreaExcelFocolaio()
        Dim xls As XlsFile = New XlsFile(True)
        Dim nomefile As String = ""
        If _ruolo = "admin" Or _ruolo = "regione" Or _ruolo = "laboratorio" Then
            nomefile = "focolai" + anno.SelectedValue + ".xlsx"
            xls.NewFile(1, TExcelFileFormat.v2007)
        Else
            nomefile = "focolai" + anno.SelectedValue + ".xls"
            xls.NewFile(1, TExcelFileFormat.v2003)
        End If

        xls.ActiveSheet = 1
        xls.SheetName = "focolaio"
        AddFocolaio(xls, loadfocolaio)
        Dim XlsStream As MemoryStream = New MemoryStream()
        Try
            If _ruolo = "admin" Or _ruolo = "regione" Then
                xls.Save(XlsStream, TFileFormats.Xlsx)

            Else
                xls.Save(XlsStream, TFileFormats.Xls)

            End If
            SendToBrowser(XlsStream, "application/excel", nomefile)
        Finally
            XlsStream.Close()
        End Try
    End Sub
    Private Function loadfocolaio() As List(Of Focolaio_exportResult)
        Try
            Dim exportFocolaio As List(Of Focolaio_exportResult) = _mbjFocolaio.Focolaio_export(ConvertEmptyStringToNothing(regionefocolaio.SelectedValue), _
                                                                                                ConvertEmptyStringToNothing(aslFocolaio.SelectedValue), _
                                                                                                ConvertIntegerToNothing(annofocolaio.SelectedValue), _
                                                                                                _Username, _
                                                                                                _usernameMedico)
            Return exportFocolaio
        Catch ex As Exception
            Throw ex
        End Try
    End Function
    Private Function loadAnagrafica() As List(Of Anagrafica_exportResult)
        Try

            Dim exportNotifica As List(Of Anagrafica_exportResult) = _mbjNotifica.ExportAnagrafica(ConvertEmptyStringToNothing(regione.SelectedValue), _
                                                                                                   ConvertEmptyStringToNothing(asl.SelectedValue), _
                                                                                                   ConvertIntegerToNothing(anno.SelectedValue), _
                                                                                                   _Username, _
                                                                                                   _usernameMedico)

            Return exportNotifica
        Catch ex As Exception
            Throw ex
        End Try
    End Function
    Private Function loadNotifica() As List(Of Notifica_exportResult)
        Try

            Dim exportNotifica As List(Of Notifica_exportResult) = _mbjNotifica.ExportNotifica(ConvertEmptyStringToNothing(regione.SelectedValue), _
                                                                                                   ConvertEmptyStringToNothing(asl.SelectedValue), _
                                                                                                   ConvertIntegerToNothing(anno.SelectedValue), _
                                                                                                   _Username, _
                                                                                                   _usernameMedico)
            Return exportNotifica
        Catch ex As Exception
            Throw ex
        End Try
    End Function
    Private Function loadClinica() As List(Of Clinica_exportResult)
        Try
            Dim exportNotifica As List(Of Clinica_exportResult) = _mbjNotifica.ExportClinica(ConvertEmptyStringToNothing(regione.SelectedValue), _
                                                                                                   ConvertEmptyStringToNothing(asl.SelectedValue), _
                                                                                                   ConvertIntegerToNothing(anno.SelectedValue), _
                                                                                                   _Username, _
                                                                                                   _usernameMedico)
            Return exportNotifica
        Catch ex As Exception
            Throw ex
        End Try
    End Function
    Private Function loadTbc() As List(Of tbc_exportResult)
        Try
            Dim exportNotifica As List(Of tbc_exportResult) = _mbjTbc.ExportTbc(ConvertEmptyStringToNothing(regione.SelectedValue), _
                                                                                                   ConvertEmptyStringToNothing(asl.SelectedValue), _
                                                                                                   ConvertIntegerToNothing(anno.SelectedValue), _
                                                                                                   _Username, _
                                                                                                   _usernameMedico)
            Return exportNotifica
        Catch ex As Exception
            Throw ex
        End Try
    End Function
    Private Function loadTbcFattori() As List(Of tbc_fattori_exportResult)
        Try
            Dim exportNotifica As List(Of tbc_fattori_exportResult) = _mbjTbc.ExportTbcFattori(ConvertEmptyStringToNothing(regione.SelectedValue), _
                                                                                                   ConvertEmptyStringToNothing(asl.SelectedValue), _
                                                                                                   ConvertIntegerToNothing(anno.SelectedValue), _
                                                                                                   _Username, _
                                                                                                   _usernameMedico)
            Return exportNotifica
        Catch ex As Exception
            Throw ex
        End Try
    End Function
    Private Function loadMib() As List(Of Notifica_Mib_EsportaResult)
        Try
            Dim exportMib As List(Of Notifica_Mib_EsportaResult) = _mobjMib.ExportMib(ConvertEmptyStringToNothing(regione.SelectedValue), _
                                                                                                   ConvertEmptyStringToNothing(asl.SelectedValue), _
                                                                                                   ConvertIntegerToNothing(anno.SelectedValue), _
                                                                                                   _Username, _
                                                                                                   _usernameMedico)
            Return exportMib
        Catch ex As Exception
            Throw ex
        End Try
    End Function
    Private Function loadMalaria() As List(Of malaria_exportResult)
        Try
            Dim exportMalaria As List(Of malaria_exportResult) = _mbjTbc.ExportMalaria(ConvertEmptyStringToNothing(regione.SelectedValue), _
                                                                                                   ConvertEmptyStringToNothing(asl.SelectedValue), _
                                                                                                   ConvertIntegerToNothing(anno.SelectedValue), _
                                                                                                   _Username, _
                                                                                                   _usernameMedico)
            Return exportMalaria
        Catch ex As Exception
            Throw ex
        End Try
    End Function
    Private Sub AddAnagrafica(ByRef xls As ExcelFile, ByVal ds As List(Of Anagrafica_exportResult))


        xls.ActiveSheet = 2
        Dim x As Integer = 1
        Dim y As Integer = 1

        xls.SetCellValue(x, 1, "idNotifica")
        xls.SetCellValue(x, 2, "Nome")
        xls.SetCellValue(x, 3, "Cognome")
        xls.SetCellValue(x, 4, "Nazione_Nascita")
        xls.SetCellValue(x, 5, "Provincia_nascita")
        xls.SetCellValue(x, 6, "Comune_Nascita")
        xls.SetCellValue(x, 7, "DataNascita")
        xls.SetCellValue(x, 8, "Eta")
        xls.SetCellValue(x, 9, "Sesso")
        xls.SetCellValue(x, 10, "CodiceFiscaleNonConosciuto")
        xls.SetCellValue(x, 11, "CodiceFiscale")
        xls.SetCellValue(x, 12, "NumeroStp")
        xls.SetCellValue(x, 13, "StranieroNonInRegola")
        xls.SetCellValue(x, 14, "SenzaFissaDimora")
        xls.SetCellValue(x, 15, "NatoEstero")
        xls.SetCellValue(x, 16, "Professione")
        xls.SetCellValue(x, 17, "Nazionalita")
        xls.SetCellValue(x, 18, "Provincia_Residenza")
        xls.SetCellValue(x, 19, "Comune_Residenza")
        xls.SetCellValue(x, 20, "IndirizzoResidenza")
        xls.SetCellValue(x, 21, "Provincia_Domicilio")
        xls.SetCellValue(x, 22, "Comune_domicilio")
        xls.SetCellValue(x, 23, "Telefono")
        xls.SetCellValue(x, 24, "CodiceRegionaleCriptazione")
        xls.SetCellValue(x, 25, "ArrivoItalia")
        xls.SetCellValue(x, 26, "CodiceEni")
        xls.SetCellValue(x, 27, "IndirizzoDomicilio")
        xls.SetCellValue(x, 28, "CIE")
        xls.SetCellValue(x, 29, "Nome CIE")
        'xls.SetCellValue(x, 28, "Deceduto")




        x = x + 1

        For Each element As Anagrafica_exportResult In ds
            With element


                Dim fmt As TFlxFormat

                xls.SetCellValue(x, 1, .idNotifica)
                If privacy.Checked Then
                    xls.SetCellValue(x, 2, "")
                    xls.SetCellValue(x, 3, "")
                Else
                    xls.SetCellValue(x, 2, .Nome)
                    xls.SetCellValue(x, 3, .Cognome)
                End If
                xls.SetCellValue(x, 4, .Nazione_Nascita)
                xls.SetCellValue(x, 5, .Provincia_nascita)
                xls.SetCellValue(x, 6, .Comune_Nascita)
                fmt = xls.GetCellVisibleFormatDef(x, 7)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 7, xls.AddFormat(fmt))
                If IsNothing(.DataNascita) Then 'data segnalazione
                    xls.SetCellValue(x, 7, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 7, FlxDateTime.ToOADate(.DataNascita, xls.OptionsDates1904))
                End If
                xls.SetCellValue(x, 8, .Eta)
                xls.SetCellValue(x, 9, .Sesso)
                xls.SetCellValue(x, 10, .CodiceFiscaleNonConosciuto)
                xls.SetCellValue(x, 11, .CodiceFiscale)
                xls.SetCellValue(x, 12, .NumeroStp)
                xls.SetCellValue(x, 13, .StranieroNonInRegola)
                xls.SetCellValue(x, 14, .SenzaFissaDimora)
                xls.SetCellValue(x, 15, .NatoEstero)
                xls.SetCellValue(x, 16, .Professione)
                xls.SetCellValue(x, 17, .Nazionalita)
                xls.SetCellValue(x, 18, .Provincia_Residenza)
                xls.SetCellValue(x, 19, .Comune_Residenza)
                xls.SetCellValue(x, 20, .IndirizzoResidenza)
                xls.SetCellValue(x, 21, .Provincia_Residenza)
                xls.SetCellValue(x, 22, .Comune_domicilio)
                xls.SetCellValue(x, 23, .Telefono)
                xls.SetCellValue(x, 24, .CodiceRegionaleCriptazione)

                xls.SetCellValue(x, 25, .ArrivoItalia)
                xls.SetCellValue(x, 26, .codiceEni)
                xls.SetCellValue(x, 27, .IndirizzoDomicilio)
                xls.SetCellValue(x, 28, .CentroPermanenza)
                xls.SetCellValue(x, 29, .NomeCentroPermanenza)



            End With
            x = x + 1
        Next
    End Sub
    Private Sub AddNotifica(ByRef xls As ExcelFile, ByVal ds As List(Of Notifica_exportResult))

        xls.ActiveSheet = 1

        Dim x As Integer = 1
        Dim y As Integer = 1

        '------------------------
        '------INTESTAZIONE------
        '------------------------

        xls.SetCellValue(x, 1, "idNotifica")
        xls.SetCellValue(x, 2, "Regione")
        xls.SetCellValue(x, 3, "AslNotifica")
        xls.SetCellValue(x, 4, "AslRes")
        xls.SetCellValue(x, 5, "stato")
        xls.SetCellValue(x, 6, "qualita")
        xls.SetCellValue(x, 7, "DataSegnalazione")
        xls.SetCellValue(x, 8, "datanotifica")
        xls.SetCellValue(x, 9, "ReferenteUlss")
        xls.SetCellValue(x, 10, "inseritaDa")
        xls.SetCellValue(x, 11, "DataWeb")



        x = x + 1

        Dim fmt As TFlxFormat
        'fmt = xls.GetCellVisibleFormatDef(x, 7)
        'fmt.Format = "dd/mm/YYYY"
        'xls.SetCellFormat(x, 7, xls.AddFormat(fmt))

        'fmt = xls.GetCellVisibleFormatDef(x, 8)
        'fmt.Format = "dd/mm/YYYY"
        'xls.SetCellFormat(x, 8, xls.AddFormat(fmt))

        'fmt = xls.GetCellVisibleFormatDef(x, 11)
        'fmt.Format = "dd/mm/YYYY"
        'xls.SetCellFormat(x, 11, xls.AddFormat(fmt))


        For Each element As Notifica_exportResult In ds

            With element
                xls.SetCellValue(x, 1, .idNotifica) 'id notifica
                xls.SetCellValue(x, 2, .Regione) 'regione
                xls.SetCellValue(x, 3, .AslNotifica) 'aslnotifica
                xls.SetCellValue(x, 4, .AslRes) 'asl residenza
                xls.SetCellValue(x, 5, .stato) 'stato
                xls.SetCellValue(x, 6, .qualita) 'qualita


                fmt = xls.GetCellVisibleFormatDef(x, 7)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 7, xls.AddFormat(fmt))
                If IsNothing(.DataSegnalazione) Then 'data segnalazione
                    xls.SetCellValue(x, 7, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 7, FlxDateTime.ToOADate(.DataSegnalazione, xls.OptionsDates1904))
                End If


                fmt = xls.GetCellVisibleFormatDef(x, 8)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 8, xls.AddFormat(fmt))
                If IsNothing(.datanotifica) Then 'datanotifica
                    xls.SetCellValue(x, 8, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 8, FlxDateTime.ToOADate(.datanotifica, xls.OptionsDates1904))
                End If

                xls.SetCellValue(x, 9, .referenteUlss) 'segnalatore
                xls.SetCellValue(x, 10, .inseritaDa) 'inserita da

                fmt = xls.GetCellVisibleFormatDef(x, 11)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 11, xls.AddFormat(fmt))
                If IsNothing(.DataWeb) Then 'data web
                    xls.SetCellValue(x, 11, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 11, FlxDateTime.ToOADate(.DataWeb, xls.OptionsDates1904))
                End If



                '-------------------------------------------
                '----------------FINE--------------------
                '-------------------------------------------

                x = x + 1
            End With
        Next


    End Sub
    Private Sub AddClinica(ByRef xls As ExcelFile, ByVal ds As List(Of Clinica_exportResult))

        xls.ActiveSheet = 3
        Dim x As Integer = 1
        Dim y As Integer = 1


        'ColFmt = xls.GetFormat(xls.GetColFormat(5))
        'ColFmt.Format = "dd/mm/YYYY"
        'xls.SetColFormat(5, xls.AddFormat(ColFmt))
        'xls.SetColWidth(17, 2742)

        'ColFmt = xls.GetFormat(xls.GetColFormat(17))
        'ColFmt.Format = "dd/mm/YYYY"
        'xls.SetColFormat(17, xls.AddFormat(ColFmt))
        'xls.SetColWidth(18, 2742)

        'ColFmt = xls.GetFormat(xls.GetColFormat(18))
        'ColFmt.Format = "dd/mm/YYYY"
        'xls.SetColFormat(18, xls.AddFormat(ColFmt))
        'xls.SetColWidth(31, 4352)

        'ColFmt = xls.GetFormat(xls.GetColFormat(31))
        'ColFmt.Format = "dd/mm/YYYY"
        'xls.SetColFormat(31, xls.AddFormat(ColFmt))

        xls.SetCellValue(x, 1, "IdNotifica")
        xls.SetCellValue(x, 2, "Malattia")
        xls.SetCellValue(x, 3, "CriterioClinico")
        xls.SetCellValue(x, 4, "CriterioEpidemiologico")
        xls.SetCellValue(x, 5, "CriterioLaboratorio")

        Dim fmt As TFlxFormat
        'fmt = xls.GetCellVisibleFormatDef(1, 5)
        'fmt.Format = "dd/mm/YYYY"
        '       xls.SetCellFormat(x, 5, xls.AddFormat(fmt))
        xls.SetCellValue(x, 6, "DataPrimiSintomi")
        xls.SetCellValue(x, 7, "nazionePrimiSintomi")
        xls.SetCellValue(x, 8, "provinciaSintomi")
        xls.SetCellValue(x, 9, "comuneSintomi")
        xls.SetCellValue(x, 10, "StatoVaccinale")
        xls.SetCellValue(x, 11, "DataDoseUltimoVaccino")
        xls.SetCellValue(x, 12, "RicoveroOspedaliero")
        xls.SetCellValue(x, 13, "LuogoRicovero")
        xls.SetCellValue(x, 14, "StrutturaRicovero")
        xls.SetCellValue(x, 15, "NomeStruttura")
        xls.SetCellValue(x, 16, "Reparto")
        xls.SetCellValue(x, 17, "MotivoDelRicovero")

        'fmt = xls.GetCellVisibleFormatDef(1, 17)
        'fmt.Format = "dd/mm/YYYY"
        '        xls.SetCellFormat(1, 17, xls.AddFormat(fmt))
        xls.SetCellValue(1, 18, "DataRicovero")

        'fmt = xls.GetCellVisibleFormatDef(1, 18)
        'fmt.Format = "dd/mm/YYYY"
        'xls.SetCellFormat(x, 18, xls.AddFormat(fmt))
        xls.SetCellValue(x, 19, "DataDimissione")
        xls.SetCellValue(x, 20, "nazioneContagio")
        xls.SetCellValue(x, 21, "provinciaContagio")
        xls.SetCellValue(x, 22, "comuneContagio")
        xls.SetCellValue(x, 23, "ViaggioFuoriResidenza")
        xls.SetCellValue(x, 24, "Localita")
        xls.SetCellValue(x, 25, "nazione1")
        xls.SetCellValue(x, 26, "nazione1Periodo")
        xls.SetCellValue(x, 27, "nazione2")
        xls.SetCellValue(x, 28, "nazione2Periodo")
        xls.SetCellValue(x, 29, "nazione3")
        xls.SetCellValue(x, 30, "nazione3Periodo")
        xls.SetCellValue(x, 31, "ricerca1")

        'fmt = xls.GetCellVisibleFormatDef(1, 31)
        'fmt.Format = "dd/mm/YYYY"
        'xls.SetCellFormat(1, 31, xls.AddFormat(fmt))
        xls.SetCellValue(x, 32, "dataesame1")
        xls.SetCellValue(x, 33, "luogo1")
        xls.SetCellValue(x, 34, "risultato1")
        xls.SetCellValue(x, 35, "ricerca2")
        xls.SetCellValue(x, 36, "dataesame2")
        xls.SetCellValue(x, 37, "luogo2")
        xls.SetCellValue(x, 38, "risultato2")
        xls.SetCellValue(x, 39, "ContattiStretti")
        xls.SetCellValue(x, 40, "comunita")
        xls.SetCellValue(x, 41, "AltraColletivita")
        xls.SetCellValue(x, 42, "Note")
        xls.SetCellValue(x, 43, "deceduto")
        xls.SetCellValue(x, 44, "nomeCommercialeVaccino")
        xls.SetCellValue(x, 45, "noteVaccino")


        x = x + 1

        For Each element As Clinica_exportResult In ds
            With element


                xls.SetCellValue(x, 1, .IdNotifica)
                xls.SetCellValue(x, 2, .malattia)
                xls.SetCellValue(x, 3, .CriterioClinico)
                xls.SetCellValue(x, 4, .CriterioEpidemiologico)
                xls.SetCellValue(x, 5, .CriterioLaboratorio)


                fmt = xls.GetCellVisibleFormatDef(x, 6)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 6, xls.AddFormat(fmt))
                If IsNothing(.DataPrimiSintomi) Then 'data segnalazione
                    xls.SetCellValue(x, 6, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 6, FlxDateTime.ToOADate(.DataPrimiSintomi, xls.OptionsDates1904))
                End If

                xls.SetCellValue(x, 7, .nazionePrimiSintomi)
                xls.SetCellValue(x, 8, .provinciaSintomi)
                xls.SetCellValue(x, 9, .comuneSintomi)
                xls.SetCellValue(x, 10, .StatoVaccinale)


                fmt = xls.GetCellVisibleFormatDef(x, 11)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 11, xls.AddFormat(fmt))
                If IsNothing(.DataDoseUltimoVaccino) Then 'data segnalazione
                    xls.SetCellValue(x, 11, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 11, FlxDateTime.ToOADate(.DataDoseUltimoVaccino, xls.OptionsDates1904))
                End If



                xls.SetCellValue(x, 12, .RicoveroOspedaliero)
                xls.SetCellValue(x, 13, .LuogoRicovero)
                xls.SetCellValue(x, 14, .StrutturaRicovero)
                xls.SetCellValue(x, 15, .NomeStruttura)
                xls.SetCellValue(x, 16, .Reparto)
                xls.SetCellValue(x, 17, .MotivoDelRicovero)

                fmt = xls.GetCellVisibleFormatDef(x, 18)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 18, xls.AddFormat(fmt))
                If IsNothing(.DataRicovero) Then 'data segnalazione
                    xls.SetCellValue(x, 18, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 18, FlxDateTime.ToOADate(.DataRicovero, xls.OptionsDates1904))
                End If

                fmt = xls.GetCellVisibleFormatDef(x, 19)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 19, xls.AddFormat(fmt))
                If IsNothing(.DataDimissione) Then 'data segnalazione
                    xls.SetCellValue(x, 19, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 19, FlxDateTime.ToOADate(.DataDimissione, xls.OptionsDates1904))
                End If

                xls.SetCellValue(x, 20, .nazioneContagio)
                xls.SetCellValue(x, 21, .provinciaContagio)
                xls.SetCellValue(x, 22, .comuneContagio)
                xls.SetCellValue(x, 23, .ViaggioFuoriResidenza)
                xls.SetCellValue(x, 24, .Localita)
                xls.SetCellValue(x, 25, .nazione1)
                xls.SetCellValue(x, 26, .nazione1Periodo)
                xls.SetCellValue(x, 27, .nazione2)
                xls.SetCellValue(x, 28, .nazione2Periodo)
                xls.SetCellValue(x, 29, .nazione3)
                xls.SetCellValue(x, 30, .nazione3Periodo)
                xls.SetCellValue(x, 31, .ricerca1)

                fmt = xls.GetCellVisibleFormatDef(x, 32)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 32, xls.AddFormat(fmt))
                If IsNothing(.dataesame1) Then 'data segnalazione
                    xls.SetCellValue(x, 32, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 32, FlxDateTime.ToOADate(.dataesame1, xls.OptionsDates1904))
                End If
                xls.SetCellValue(x, 33, .luogo1)
                xls.SetCellValue(x, 34, .risultato1)
                xls.SetCellValue(x, 35, .ricerca2)

                fmt = xls.GetCellVisibleFormatDef(x, 36)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 36, xls.AddFormat(fmt))

                If IsNothing(.dataesame2) Then 'data segnalazione
                    xls.SetCellValue(x, 36, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 36, FlxDateTime.ToOADate(.dataesame2, xls.OptionsDates1904))
                End If
                xls.SetCellValue(x, 37, .luogo2)
                xls.SetCellValue(x, 38, .risultato2)
                xls.SetCellValue(x, 39, .ContattiStretti)
                xls.SetCellValue(x, 40, .comunita)
                xls.SetCellValue(x, 41, .AltraColletivita)
                xls.SetCellValue(x, 42, .Note)
                xls.SetCellValue(x, 43, .deceduto)

                xls.SetCellValue(x, 44, .NomeCommercialeVaccino)
                xls.SetCellValue(x, 45, .noteVaccino)

            End With
            x = x + 1
        Next



    End Sub
    Private Sub AddTbc(ByRef xls As ExcelFile, ByVal ds As List(Of tbc_exportResult))
        xls.ActiveSheet = 4
        Dim x As Integer = 1
        Dim y As Integer = 1

        xls.SetCellValue(x, 1, "idNotifica")
        xls.SetCellValue(x, 2, "tipo")
        xls.SetCellValue(x, 3, "DataInizioTerapia")
        xls.SetCellValue(x, 4, "LivelloDiAccertamento")
        xls.SetCellValue(x, 5, "DiagnosiTbcPassato")
        xls.SetCellValue(x, 6, "MeseTbcPAssato")
        xls.SetCellValue(x, 7, "AnnoTbcPassato")
        xls.SetCellValue(x, 8, "TipoClassificazione")
        xls.SetCellValue(x, 9, "AgenteEziologico")
        xls.SetCellValue(x, 10, "AltroAgente")
        xls.SetCellValue(x, 11, "Antibiogramma")
        xls.SetCellValue(x, 12, "STRE")
        xls.SetCellValue(x, 13, "INH")
        xls.SetCellValue(x, 14, "RMP")
        xls.SetCellValue(x, 15, "EMB")
        xls.SetCellValue(x, 16, "PZA")
        xls.SetCellValue(x, 17, "EsameColturaleEscreato")
        xls.SetCellValue(x, 18, "EsameColturaleAltroMateriale")
        xls.SetCellValue(x, 19, "EsameColturaleAltroDesc")
        xls.SetCellValue(x, 20, "EsameDirettoEscreato")
        xls.SetCellValue(x, 21, "Esamedirettoaltromateriale")
        xls.SetCellValue(x, 22, "EsamedirettoaltromaterialeDesc")
        xls.SetCellValue(x, 23, "Clinica")
        xls.SetCellValue(x, 24, "Mantoux")
        xls.SetCellValue(x, 25, "RxStandard")
        xls.SetCellValue(x, 26, "RispostaTerapia")
        xls.SetCellValue(x, 27, "RiscontroAutopico")
        xls.SetCellValue(x, 28, "SedePolmonare")
        xls.SetCellValue(x, 29, "ExtraPolmonare")
        xls.SetCellValue(x, 30, "localizzazione1")
        xls.SetCellValue(x, 31, "localizzazione2")
        xls.SetCellValue(x, 32, "Miliare")
        xls.SetCellValue(x, 33, "Disseminata")
        xls.SetCellValue(x, 34, "MotivoIterDiagnostico")
        xls.SetCellValue(x, 35, "TipoIterDiagnostico")
        xls.SetCellValue(x, 36, "DataInizioTerapiaCentro")
        xls.SetCellValue(x, 37, "Isoniazide")
        xls.SetCellValue(x, 38, "IsoniazideInizio")
        xls.SetCellValue(x, 39, "IsoniazideFine")


        xls.SetCellValue(x, 40, "Rifampicina")
        xls.SetCellValue(x, 41, "RifampicinaInizio")
        xls.SetCellValue(x, 42, "RifampicinaFine")

        xls.SetCellValue(x, 43, "Pirazinamide")
        xls.SetCellValue(x, 44, "PirazinamideInizio")
        xls.SetCellValue(x, 45, "PirazinamideFine")



        xls.SetCellValue(x, 46, "Etambutolo")
        xls.SetCellValue(x, 47, "EtambutoloInizio")
        xls.SetCellValue(x, 48, "EtambutoloFine")

        xls.SetCellValue(x, 49, "Farmaco1")
        xls.SetCellValue(x, 50, "Farmaco1Inizio")
        xls.SetCellValue(x, 51, "Farmaco1Fine")

        xls.SetCellValue(x, 52, "Farmaco2")
        xls.SetCellValue(x, 53, "Farmaco2Inizio")
        xls.SetCellValue(x, 54, "Farmaco2Fine")

        xls.SetCellValue(x, 55, "Farmaco3")
        xls.SetCellValue(x, 56, "Farmaco3Inizio")
        xls.SetCellValue(x, 57, "Farmaco3Fine")

        xls.SetCellValue(x, 58, "Farmaco4")
        xls.SetCellValue(x, 59, "Farmaco4Inizio")
        xls.SetCellValue(x, 60, "Farmaco4Fine")




        xls.SetCellValue(x, 61, "TerapiaModificata")
        xls.SetCellValue(x, 62, "Esito")
        xls.SetCellValue(x, 63, "trasferito")
        xls.SetCellValue(x, 64, "trattamentoInterotto")
        xls.SetCellValue(x, 65, "DataChiusura")
        xls.SetCellValue(x, 66, "Note")

        x = x + 1

        Dim fmt As TFlxFormat


        For Each element As tbc_exportResult In ds
            With element


                xls.SetCellValue(x, 1, .idNotifica)
                xls.SetCellValue(x, 2, .tipo)

                fmt = xls.GetCellVisibleFormatDef(x, 3)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 3, xls.AddFormat(fmt))
                If IsNothing(.DataInizioTerapia) Then 'data segnalazione
                    xls.SetCellValue(x, 3, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 3, FlxDateTime.ToOADate(.DataInizioTerapia, xls.OptionsDates1904))
                End If
                'xls.SetCellValue(x, 3, .DataInizioTerapia)
                xls.SetCellValue(x, 4, .LivelloDiAccertamento)
                xls.SetCellValue(x, 5, .DiagnosiTbcPassato)
                xls.SetCellValue(x, 6, .MeseTbcPAssato)
                xls.SetCellValue(x, 7, .AnnoTbcPassato)
                xls.SetCellValue(x, 8, .TipoClassificazione)
                xls.SetCellValue(x, 9, .AgenteEziologico)
                xls.SetCellValue(x, 10, .AltroAgente)
                xls.SetCellValue(x, 11, .Antibiogramma)
                xls.SetCellValue(x, 12, .STRE)
                xls.SetCellValue(x, 13, .INH)
                xls.SetCellValue(x, 14, .RMP)
                xls.SetCellValue(x, 15, .EMB)
                xls.SetCellValue(x, 16, .PZA)
                xls.SetCellValue(x, 17, .EsameColturaleEscreato)
                xls.SetCellValue(x, 18, .EsameColturaleAltroMateriale)
                xls.SetCellValue(x, 19, .EsameColturaleAltroDesc)
                xls.SetCellValue(x, 20, .EsameDirettoEscreato)
                xls.SetCellValue(x, 21, .Esamedirettoaltromateriale)
                xls.SetCellValue(x, 22, .EsamedirettoaltromaterialeDesc)
                xls.SetCellValue(x, 23, .Clinica)
                xls.SetCellValue(x, 24, .Mantoux)
                xls.SetCellValue(x, 25, .RxStandard)
                xls.SetCellValue(x, 26, .RispostaTerapia)
                xls.SetCellValue(x, 27, .RiscontroAutopico)
                xls.SetCellValue(x, 28, .SedePolmonare)
                xls.SetCellValue(x, 29, .ExtraPolmonare)
                xls.SetCellValue(x, 30, .localizzazione1)
                xls.SetCellValue(x, 31, .localizzazione2)
                xls.SetCellValue(x, 32, .Miliare)
                xls.SetCellValue(x, 33, .Disseminata)
                xls.SetCellValue(x, 34, .MotivoIterDiagnostico)
                xls.SetCellValue(x, 35, .TipoIterDiagnostico)

                fmt = xls.GetCellVisibleFormatDef(x, 36)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 36, xls.AddFormat(fmt))
                If IsNothing(.DataInizioTerapiaCentro) Then 'data segnalazione
                    xls.SetCellValue(x, 36, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 36, FlxDateTime.ToOADate(.DataInizioTerapiaCentro, xls.OptionsDates1904))
                End If

                'xls.SetCellValue(x, 36, .DataInizioTerapiaCentro)
                xls.SetCellValue(x, 37, .Isoniazide)
                xls.SetCellValue(x, 38, .IsoniazideInizio)
                xls.SetCellValue(x, 39, .IsoniazideFine)


                xls.SetCellValue(x, 40, .Rifampicin)
                xls.SetCellValue(x, 41, .RifampicinaInizio)
                xls.SetCellValue(x, 42, .RifampicinaFine)

                xls.SetCellValue(x, 43, .Pirazinamide)
                xls.SetCellValue(x, 44, .PirazinamideInizio)
                xls.SetCellValue(x, 45, .PirazinamideFine)

                xls.SetCellValue(x, 46, .Etambutolo)
                xls.SetCellValue(x, 47, .EtambutoloInizio)
                xls.SetCellValue(x, 48, .EtambutoloFine)

                xls.SetCellValue(x, 49, .Altro1)
                xls.SetCellValue(x, 50, .Altro1Inizio)
                xls.SetCellValue(x, 51, .Altro1Fine)

                xls.SetCellValue(x, 52, .Altro2)
                xls.SetCellValue(x, 53, .Altro2Inizio)
                xls.SetCellValue(x, 54, .Altro2Fine)

                xls.SetCellValue(x, 55, .Altro3)
                xls.SetCellValue(x, 56, .Altro3Inizio)
                xls.SetCellValue(x, 57, .Altro3Fine)

                xls.SetCellValue(x, 58, .Altro4)
                xls.SetCellValue(x, 59, .Altro4Inizio)
                xls.SetCellValue(x, 60, .Altro4Fine)

                xls.SetCellValue(x, 61, .TerapiaModificata)
                xls.SetCellValue(x, 62, .Esito)
                xls.SetCellValue(x, 63, .trasferito)
                xls.SetCellValue(x, 64, .trattamentoInterotto)
                fmt = xls.GetCellVisibleFormatDef(x, 65)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 65, xls.AddFormat(fmt))
                If IsNothing(.DataChiusura) Then 'data segnalazione
                    xls.SetCellValue(x, 65, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 65, FlxDateTime.ToOADate(.DataChiusura, xls.OptionsDates1904))
                End If
                'xls.SetCellValue(x, 49, .DataChiusura)
                xls.SetCellValue(x, 66, .Note)

            End With

            x = x + 1
        Next


    End Sub
    Private Sub addTbcFattori(ByRef xls As ExcelFile, ByVal ds As List(Of tbc_fattori_exportResult))


        xls.ActiveSheet = 5
        Dim x As Integer = 1
        Dim y As Integer = 1


        xls.SetCellValue(x, 1, "idNotifica")
        xls.SetCellValue(x, 2, "esitiradiografici")
        xls.SetCellValue(x, 3, "graveimmudeficenza")
        xls.SetCellValue(x, 4, "terapiaImmunosoppresiva")
        xls.SetCellValue(x, 5, "deperimentoOrganico")
        xls.SetCellValue(x, 6, "recenteViaggioTbc")
        xls.SetCellValue(x, 7, "diabeteScarsamenteControllato")
        xls.SetCellValue(x, 8, "silicosi")
        xls.SetCellValue(x, 9, "insufficenzaRenale")
        xls.SetCellValue(x, 10, "gastrectomia")
        xls.SetCellValue(x, 11, "ContattoMalato")
        xls.SetCellValue(x, 12, "tossicodipendenza")
        xls.SetCellValue(x, 13, "Immigrazione")
        xls.SetCellValue(x, 14, "carcere")
        xls.SetCellValue(x, 15, "alcolismo")
        xls.SetCellValue(x, 16, "senzaFissaDimora")
        xls.SetCellValue(x, 17, "personaleSanitario")
        xls.SetCellValue(x, 18, "Altro")


        x = x + 1

        For Each element As tbc_fattori_exportResult In ds
            With element
                xls.SetCellValue(x, 1, .idNotifica)
                xls.SetCellValue(x, 2, .esitiradiografici)
                xls.SetCellValue(x, 3, .graveimmudeficenza)
                xls.SetCellValue(x, 4, .terapiaImmunosoppresiva)
                xls.SetCellValue(x, 5, .deperimentoOrganico)
                xls.SetCellValue(x, 6, .recenteViaggioTbc)
                xls.SetCellValue(x, 7, .diabeteScarsamenteControllato)
                xls.SetCellValue(x, 8, .silicosi)
                xls.SetCellValue(x, 9, .insufficenzaRenale)
                xls.SetCellValue(x, 10, .gastrectomia)
                xls.SetCellValue(x, 11, .ContattoMalato)
                xls.SetCellValue(x, 12, .tossicodipendenza)
                xls.SetCellValue(x, 13, .Immigrazione)
                xls.SetCellValue(x, 14, .carcere)
                xls.SetCellValue(x, 15, .alcolismo)
                xls.SetCellValue(x, 16, .senzaFissaDimora)
                xls.SetCellValue(x, 17, .personaleSanitario)
                xls.SetCellValue(x, 18, .Altro)
            End With
            x = x + 1
        Next





    End Sub
    Private Sub AddFocolaio(ByRef xls As ExcelFile, ByVal ds As List(Of Focolaio_exportResult))

        Dim fmt As TFlxFormat
        xls.ActiveSheet = 1
        Dim x As Integer = 1
        Dim y As Integer = 1

        xls.SetCellValue(x, 1, "malattia")
        xls.SetCellValue(1, 2, "regione")
        xls.SetCellValue(1, 3, "Provincia")
        xls.SetCellValue(1, 4, "Comune")
        xls.SetCellValue(1, 5, "Comunita")
        xls.SetCellValue(1, 6, "PersoneRischio")
        xls.SetCellValue(1, 7, "Indirizzo")
        xls.SetCellValue(1, 8, "Telefono")
        xls.SetCellValue(1, 9, "agente")
        xls.SetCellValue(1, 10, "agenteIdentificato")
        xls.SetCellValue(1, 11, "Veicolo")
        xls.SetCellValue(1, 12, "veicoloIdentificato")
        xls.SetCellValue(1, 13, "dataInizio")
        xls.SetCellValue(1, 14, "durata")
        xls.SetCellValue(1, 15, "NumeroCasi")
        xls.SetCellValue(1, 16, "LuogoOrigine")
        xls.SetCellValue(1, 17, "Note")
        xls.SetCellValue(1, 18, "Stato")
        xls.SetCellValue(1, 19, "AslDiResidenza")
        xls.SetCellValue(1, 20, "AslDiNotifica")
        xls.SetCellValue(1, 21, "DataSegnalazione")
        xls.SetCellValue(1, 22, "DataNotifica")
        xls.SetCellValue(1, 23, "DataWeb")

        x = x + 1

        For Each element As Focolaio_exportResult In ds
            With element


                xls.SetCellValue(x, 1, .malattia)
                xls.SetCellValue(x, 2, .regione)
                xls.SetCellValue(x, 3, .Provincia)
                xls.SetCellValue(x, 4, .Comune)
                xls.SetCellValue(x, 5, .Comunita)
                xls.SetCellValue(x, 6, .PersoneRischio)
                xls.SetCellValue(x, 7, .Indirizzo)
                xls.SetCellValue(x, 8, .Telefono)
                xls.SetCellValue(x, 9, .agente)
                xls.SetCellValue(x, 10, .agenteIdentificato)
                xls.SetCellValue(x, 11, .Veicolo)
                xls.SetCellValue(x, 12, .veicoloIdentificato)

                fmt = xls.GetCellVisibleFormatDef(x, 14)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 14, xls.AddFormat(fmt))
                If IsNothing(.dataInizio) Then 'data segnalazione
                    xls.SetCellValue(x, 14, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 14, FlxDateTime.ToOADate(.dataInizio, xls.OptionsDates1904))
                End If
                xls.SetCellValue(x, 13, .dataInizio)
                xls.SetCellValue(x, 14, .durata)
                xls.SetCellValue(x, 15, .NumeroCasi)
                xls.SetCellValue(x, 16, .LuogoOrigine)
                xls.SetCellValue(x, 17, .Note)
                xls.SetCellValue(x, 18, .Stato)
                xls.SetCellValue(x, 19, .AslDiResidenza)
                xls.SetCellValue(x, 20, .AslDiNotifica)
                fmt = xls.GetCellVisibleFormatDef(x, 21)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 21, xls.AddFormat(fmt))
                If IsNothing(.DataSegnalazione) Then 'data segnalazione
                    xls.SetCellValue(x, 21, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 21, FlxDateTime.ToOADate(.DataSegnalazione, xls.OptionsDates1904))
                End If

                fmt = xls.GetCellVisibleFormatDef(x, 22)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 22, xls.AddFormat(fmt))
                If IsNothing(.DataNotifica) Then 'data segnalazione
                    xls.SetCellValue(x, 22, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 22, FlxDateTime.ToOADate(.DataNotifica, xls.OptionsDates1904))
                End If

                fmt = xls.GetCellVisibleFormatDef(x, 23)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 23, xls.AddFormat(fmt))
                If IsNothing(.DataWeb) Then 'data segnalazione
                    xls.SetCellValue(x, 23, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 23, FlxDateTime.ToOADate(.DataWeb, xls.OptionsDates1904))
                End If

            End With

            x = x + 1
        Next

    End Sub
    Private Sub AddMib(ByRef xls As ExcelFile, ByVal ds As List(Of Notifica_Mib_EsportaResult))
        Dim fmt As TFlxFormat
        xls.ActiveSheet = 6
        Dim x As Integer = 1
        Dim y As Integer = 1
        xls.SetCellValue(x, 1, "id")
        xls.SetCellValue(x, 2, "idNotifica")
        xls.SetCellValue(x, 3, "Qc_Sepsi")
        xls.SetCellValue(x, 4, "Qc_Meningite")
        xls.SetCellValue(x, 5, "QC_Cellulite")
        xls.SetCellValue(x, 6, "QC_Epiglottite")
        xls.SetCellValue(x, 7, "QC_Peritonite")
        xls.SetCellValue(x, 8, "QC_Pericardite")
        xls.SetCellValue(x, 9, "QC_Artrite")
        xls.SetCellValue(x, 10, "Qc_Polmonite")
        xls.SetCellValue(x, 11, "QC_Altro")
        xls.SetCellValue(x, 12, "Qc_AltroSpecificare")
        xls.SetCellValue(x, 13, "IdAgenteEziologico")
        xls.SetCellValue(x, 14, "AltroAgente")
        xls.SetCellValue(x, 15, "Liquor")
        xls.SetCellValue(x, 16, "NoteDiagnosi")
        xls.SetCellValue(x, 17, "ContattoLab")
        xls.SetCellValue(x, 18, "ContattoTelefono")
        xls.SetCellValue(x, 19, "ContattoOspedale")
        xls.SetCellValue(x, 20, "Metodo1")
        xls.SetCellValue(x, 21, "Materiale1")
        xls.SetCellValue(x, 22, "Metodo2")
        xls.SetCellValue(x, 23, "Materiale2")
        xls.SetCellValue(x, 24, "Tipizzazione")
        xls.SetCellValue(x, 25, "LabTipizzazione")
        xls.SetCellValue(x, 26, "LabBatterio")
        xls.SetCellValue(x, 27, "LabAltroBatterio")
        xls.SetCellValue(x, 28, "LabSierogruppoMen")
        xls.SetCellValue(x, 29, "LabSierotipoPNU")
        xls.SetCellValue(x, 30, "Pg_Val")
        xls.SetCellValue(x, 31, "Pg_Mic")
        xls.SetCellValue(x, 32, "Pg_Cat")
        xls.SetCellValue(x, 33, "Pg_Val_Est")
        xls.SetCellValue(x, 34, "Pg_Mic_Est")
        xls.SetCellValue(x, 35, "Pg_Cat_ESt")
        xls.SetCellValue(x, 36, "Pg_disco")
        xls.SetCellValue(x, 37, "Pg_Disco_Cat")
        xls.SetCellValue(x, 38, "Em_val")
        xls.SetCellValue(x, 39, "Em_Mic")
        xls.SetCellValue(x, 40, "Em_Cat")
        xls.SetCellValue(x, 41, "Em_val_est")
        xls.SetCellValue(x, 42, "Em_Mic_Est")
        xls.SetCellValue(x, 43, "Em_Cat_Est")
        xls.SetCellValue(x, 44, "Em_disco")
        xls.SetCellValue(x, 45, "Em_Disco_Cat")
        xls.SetCellValue(x, 46, "Cip_Val")
        xls.SetCellValue(x, 47, "Cip_Mic")
        xls.SetCellValue(x, 48, "Cip_Cat")
        xls.SetCellValue(x, 49, "Cip_Val_Est")
        xls.SetCellValue(x, 50, "Cip_Mic_Est")
        xls.SetCellValue(x, 51, "Cip_Cat_Est")
        xls.SetCellValue(x, 52, "Cip_Disco")
        xls.SetCellValue(x, 53, "Cip_Disco_Cat")
        xls.SetCellValue(x, 54, "Cli_Val")
        xls.SetCellValue(x, 55, "Cli_Mic")
        xls.SetCellValue(x, 56, "Cli_Cat")
        xls.SetCellValue(x, 57, "Cli_Val_Est")
        xls.SetCellValue(x, 58, "Cli_Mic_Est")
        xls.SetCellValue(x, 59, "Cli_Cat_Est")
        xls.SetCellValue(x, 60, "Cli_Disco")
        xls.SetCellValue(x, 61, "Cli_Disco_Cat")
        xls.SetCellValue(x, 62, "LabSierotipoHI")
        xls.SetCellValue(x, 63, "LabNote")
        xls.SetCellValue(x, 64, "LastUser")
        xls.SetCellValue(x, 65, "dataprelievo")



        xls.SetCellValue(x, 66, "Esito")
        xls.SetCellValue(x, 67, "Esito14gg")
        xls.SetCellValue(x, 68, "condizioni")
        xls.SetCellValue(x, 69, "Con_Asplenia")
        xls.SetCellValue(x, 70, "Con_Immunodeficienza")
        xls.SetCellValue(x, 71, "Con_Leucemie")
        xls.SetCellValue(x, 72, "Con_neoplasie")
        xls.SetCellValue(x, 73, "Con_TerapieImmuno")
        xls.SetCellValue(x, 74, "Con_Altrocondizione")
        xls.SetCellValue(x, 75, "Con_Trapianto")
        xls.SetCellValue(x, 76, "Con_cocleare")
        xls.SetCellValue(x, 77, "Con_Fistole")
        xls.SetCellValue(x, 78, "Con_Immunodeficienzaacquisita")
        xls.SetCellValue(x, 79, "Con_Insufficenzarenale")
        xls.SetCellValue(x, 80, "Con_Diabete")
        xls.SetCellValue(x, 81, "Con_Epatopatia")
        xls.SetCellValue(x, 82, "Con_Cardiopatie")
        xls.SetCellValue(x, 83, "Con_Asma")
        xls.SetCellValue(x, 84, "Con_Tossicodipendenza")
        xls.SetCellValue(x, 85, "Con_Alcolismo")
        xls.SetCellValue(x, 86, "Con_Tabagismo")
        xls.SetCellValue(x, 87, "Con_altrospecificare")
        xls.SetCellValue(x, 88, "Sequele")
        xls.SetCellValue(x, 89, "SequeleUdito")
        xls.SetCellValue(x, 90, "SequelVista")
        xls.SetCellValue(x, 91, "SequeleNeuro")
        xls.SetCellValue(x, 92, "SequeleAmputazione")
        xls.SetCellValue(x, 93, "SequeleNecrosi")
        xls.SetCellValue(x, 94, "SequeleAltro")
        xls.SetCellValue(x, 95, "SequeleAltroSpecificare")





        x = x + 1

        For Each element As Notifica_Mib_EsportaResult In ds
            With element
                xls.SetCellValue(x, 1, .id)
                xls.SetCellValue(x, 2, .idNotifica)
                xls.SetCellValue(x, 3, .Qc_Sepsi)
                xls.SetCellValue(x, 4, .Qc_Meningite)
                xls.SetCellValue(x, 5, .QC_Cellulite)
                xls.SetCellValue(x, 6, .QC_Epiglottite)
                xls.SetCellValue(x, 7, .QC_Peritonite)
                xls.SetCellValue(x, 8, .QC_Pericardite)
                xls.SetCellValue(x, 9, .QC_Artrite)
                xls.SetCellValue(x, 10, .Qc_Polmonite)
                xls.SetCellValue(x, 11, .QC_Altro)
                xls.SetCellValue(x, 12, .Qc_AltroSpecificare)
                xls.SetCellValue(x, 13, .IdAgenteEziologico)
                xls.SetCellValue(x, 14, .AltroAgente)
                xls.SetCellValue(x, 15, .Liquor)
                xls.SetCellValue(x, 16, .NoteDiagnosi)
                xls.SetCellValue(x, 17, .ContattoLab)
                xls.SetCellValue(x, 18, .ContattoTelefono)
                xls.SetCellValue(x, 19, .ContattoOspedale)
                xls.SetCellValue(x, 20, .Metodo1)
                xls.SetCellValue(x, 21, .Materiale1)
                xls.SetCellValue(x, 22, .Metodo2)
                xls.SetCellValue(x, 23, .Materiale2)
                xls.SetCellValue(x, 24, .Tipizzazione)
                xls.SetCellValue(x, 25, .LabTipizzazione)
                xls.SetCellValue(x, 26, .LabBatterio)
                xls.SetCellValue(x, 27, .LabAltroBatterio)
                xls.SetCellValue(x, 28, .LabSierogruppoMen)
                xls.SetCellValue(x, 29, .LabSierotipoPNU)
                xls.SetCellValue(x, 30, .Pg_Val)
                xls.SetCellValue(x, 31, .Pg_Mic)
                xls.SetCellValue(x, 32, .Pg_Cat)
                xls.SetCellValue(x, 33, .Pg_Val_Est)
                xls.SetCellValue(x, 34, .Pg_Mic_Est)
                xls.SetCellValue(x, 35, .Pg_Cat_ESt)
                xls.SetCellValue(x, 36, .Pg_disco)
                xls.SetCellValue(x, 37, .Pg_Disco_Cat)
                xls.SetCellValue(x, 38, .Em_val)
                xls.SetCellValue(x, 39, .Em_Mic)
                xls.SetCellValue(x, 40, .Em_Cat)
                xls.SetCellValue(x, 41, .Em_val_est)
                xls.SetCellValue(x, 42, .Em_Mic_Est)
                xls.SetCellValue(x, 43, .Em_Cat_Est)
                xls.SetCellValue(x, 44, .Em_disco)
                xls.SetCellValue(x, 45, .Em_Disco_Cat)
                xls.SetCellValue(x, 46, .Cip_Val)
                xls.SetCellValue(x, 47, .Cip_Mic)
                xls.SetCellValue(x, 48, .Cip_Cat)
                xls.SetCellValue(x, 49, .Cip_Val_Est)
                xls.SetCellValue(x, 50, .Cip_Mic_Est)
                xls.SetCellValue(x, 51, .Cip_Cat_Est)
                xls.SetCellValue(x, 52, .Cip_Disco)
                xls.SetCellValue(x, 53, .Cip_Disco_Cat)
                xls.SetCellValue(x, 54, .Cli_Val)
                xls.SetCellValue(x, 55, .Cli_Mic)
                xls.SetCellValue(x, 56, .Cli_Cat)
                xls.SetCellValue(x, 57, .Cli_Val_Est)
                xls.SetCellValue(x, 58, .Cli_Mic_Est)
                xls.SetCellValue(x, 59, .Cli_Cat_Est)
                xls.SetCellValue(x, 60, .Cli_Disco)
                xls.SetCellValue(x, 61, .Cli_Disco_Cat)
                xls.SetCellValue(x, 62, .LabSierotipoHI)
                xls.SetCellValue(x, 63, .LabNote)
                xls.SetCellValue(x, 64, .LastUser)

                fmt = xls.GetCellVisibleFormatDef(x, 65)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 65, xls.AddFormat(fmt))
                If IsNothing(.dataprelievo) Then 'data segnalazione
                    xls.SetCellValue(x, 21, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 65, FlxDateTime.ToOADate(.dataprelievo, xls.OptionsDates1904))
                End If

                xls.SetCellValue(x, 66, .Esito)
                xls.SetCellValue(x, 67, .Esito14gg)
                xls.SetCellValue(x, 68, .condizioni)
                xls.SetCellValue(x, 69, .Con_Asplenia)
                xls.SetCellValue(x, 70, .Con_Immunodeficienza)
                xls.SetCellValue(x, 71, .Con_Leucemie)
                xls.SetCellValue(x, 72, .Con_neoplasie)
                xls.SetCellValue(x, 73, .Con_TerapieImmuno)
                xls.SetCellValue(x, 74, .Con_Altrocondizione)
                xls.SetCellValue(x, 75, .Con_Trapianto)
                xls.SetCellValue(x, 76, .Con_cocleare)
                xls.SetCellValue(x, 77, .Con_Fistole)
                xls.SetCellValue(x, 78, .Con_Immunodeficienzaacquisita)
                xls.SetCellValue(x, 79, .Con_Insufficenzarenale)
                xls.SetCellValue(x, 80, .Con_Diabete)
                xls.SetCellValue(x, 81, .Con_Epatopatia)
                xls.SetCellValue(x, 82, .Con_Cardiopatie)
                xls.SetCellValue(x, 83, .Con_Asma)
                xls.SetCellValue(x, 84, .Con_Tossicodipendenza)
                xls.SetCellValue(x, 85, .Con_Alcolismo)
                xls.SetCellValue(x, 86, .Con_Tabagismo)
                xls.SetCellValue(x, 87, .Con_altrospecificare)
                xls.SetCellValue(x, 88, .Sequele)
                xls.SetCellValue(x, 89, .SequeleUdito)
                xls.SetCellValue(x, 90, .SequelVista)
                xls.SetCellValue(x, 91, .SequeleNeuro)
                xls.SetCellValue(x, 92, .SequeleAmputazione)
                xls.SetCellValue(x, 93, .SequeleNecrosi)
                xls.SetCellValue(x, 94, .SequeleAltro)
                xls.SetCellValue(x, 95, .SequeleAltroSpecificare)

            End With
            x = x + 1
        Next

    End Sub


    Protected Sub notifica_Click(sender As Object, e As System.EventArgs) Handles notifica.Click
        CreaExcel()
    End Sub


    Protected Sub focolaio_Click(sender As Object, e As System.EventArgs) Handles focolaio.Click
        CreaExcelFocolaio()
    End Sub
    Private Sub bindCombo()

        Dim annocorrente As Integer = DatePart(DateInterval.Year, Now())

        anno.Items.Add(New ListItem("Tutti", ""))
        annofocolaio.Items.Add(New ListItem("Tutti", ""))
        For i = 2008 To annocorrente
            anno.Items.Add(New ListItem(i.ToString, i.ToString))
        Next

        For i = 2008 To annocorrente
            annofocolaio.Items.Add(New ListItem(i.ToString, i.ToString))
        Next

    End Sub


    Private Sub AddMalaria(ByRef xls As ExcelFile, ByVal ds As List(Of malaria_exportResult))


        xls.ActiveSheet = 7
        Dim x As Integer = 1
        Dim y As Integer = 1

        xls.SetCellValue(x, 1, "idNotifica")
        xls.SetCellValue(x, 2, "tipo")
        xls.SetCellValue(x, 3, "dataClinica")
        xls.SetCellValue(x, 4, "dataEmoscopia")
        xls.SetCellValue(x, 5, "speciePlasmodio")
        xls.SetCellValue(x, 6, "formeMisteSpecificare")
        xls.SetCellValue(x, 7, "terapia")
        xls.SetCellValue(x, 8, "altraTerapia")
        xls.SetCellValue(x, 9, "faramcoResistenza")
        xls.SetCellValue(x, 10, "prevenzioneRicevuta")
        xls.SetCellValue(x, 11, "AltroEnte")
        xls.SetCellValue(x, 12, "chemioprofilassi")
        xls.SetCellValue(x, 13, "farmaciChemioprofilassi")
        xls.SetCellValue(x, 14, "assunzioniInterrotte")
        xls.SetCellValue(x, 15, "chemioProfilassiCompletata")
        xls.SetCellValue(x, 16, "motivoInterruzione")
        xls.SetCellValue(x, 17, "Effetto1")
        xls.SetCellValue(x, 18, "altroEffetto1Specificare")
        xls.SetCellValue(x, 19, "Effetto2")
        xls.SetCellValue(x, 20, "altroEffetto2Specificare")
        xls.SetCellValue(x, 21, "protezionePunture")
        xls.SetCellValue(x, 22, "zanzareZoneRischio")
        xls.SetCellValue(x, 23, "Repellenti")
        xls.SetCellValue(x, 24, "specificaRepellente")
        xls.SetCellValue(x, 25, "Emoscopiapervenuta")
        xls.SetCellValue(x, 26, "Emoscopiacontrollo")
        xls.SetCellValue(x, 27, "dataweb")
        xls.SetCellValue(x, 28, "datamodifica")
        xls.SetCellValue(x, 29, "lastUser")




        x = x + 1

        For Each element As malaria_exportResult In ds
            With element


                Dim fmt As TFlxFormat

                xls.SetCellValue(x, 1, .idNotifica)
                xls.SetCellValue(x, 2, .tipo)


                fmt = xls.GetCellVisibleFormatDef(x, 3)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 3, xls.AddFormat(fmt))
                If IsNothing(.dataClinica) Then 'data segnalazione
                    xls.SetCellValue(x, 3, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 3, FlxDateTime.ToOADate(.dataClinica, xls.OptionsDates1904))
                End If

                fmt = xls.GetCellVisibleFormatDef(x, 4)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 4, xls.AddFormat(fmt))
                If IsNothing(.dataEmoscopia) Then 'data segnalazione
                    xls.SetCellValue(x, 4, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 4, FlxDateTime.ToOADate(.dataEmoscopia, xls.OptionsDates1904))
                End If

                xls.SetCellValue(x, 5, .speciePlasmodio)
                xls.SetCellValue(x, 6, .formeMisteSpecificare)
                xls.SetCellValue(x, 7, .terapia)
                xls.SetCellValue(x, 8, .altraTerapia)
                xls.SetCellValue(x, 9, .faramcoResistenza)
                xls.SetCellValue(x, 10, .prevenzioneRicevuta)
                xls.SetCellValue(x, 11, .AltroEnte)
                xls.SetCellValue(x, 12, .chemioprofilassi)
                xls.SetCellValue(x, 13, .farmaciChemioprofilassi)
                xls.SetCellValue(x, 14, .assunzioniInterrotte)
                xls.SetCellValue(x, 15, .chemioProfilassiCompletata)
                xls.SetCellValue(x, 16, .motivoInterruzione)
                xls.SetCellValue(x, 17, .Effetto1)
                xls.SetCellValue(x, 18, .altroEffetto1Specificare)
                xls.SetCellValue(x, 19, .Effetto2)
                xls.SetCellValue(x, 20, .altroEffetto2Specificare)
                xls.SetCellValue(x, 21, .protezionePunture)
                xls.SetCellValue(x, 22, .zanzareZoneRischio)
                xls.SetCellValue(x, 23, .Repellenti)
                xls.SetCellValue(x, 24, .specificaRepellente)
                xls.SetCellValue(x, 25, .Emoscopiapervenuta)
                xls.SetCellValue(x, 26, .Emoscopiacontrollo)

                fmt = xls.GetCellVisibleFormatDef(x, 27)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 27, xls.AddFormat(fmt))
                If IsNothing(.dataweb) Then 'data segnalazione
                    xls.SetCellValue(x, 27, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 27, FlxDateTime.ToOADate(.dataweb, xls.OptionsDates1904))
                End If

                fmt = xls.GetCellVisibleFormatDef(x, 28)
                fmt.Format = "dd/mm/YYYY"
                xls.SetCellFormat(x, 28, xls.AddFormat(fmt))
                If IsNothing(.datamodifica) Then 'data segnalazione
                    xls.SetCellValue(x, 28, "", xls.OptionsDates1904)
                Else

                    xls.SetCellValue(x, 28, FlxDateTime.ToOADate(.datamodifica, xls.OptionsDates1904))
                End If
                xls.SetCellValue(x, 29, .lastUser)

                x = x + 1
            End With
        Next
    End Sub

End Class

























































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































